summaryrefslogtreecommitdiffstats
path: root/tests/ts/kill
diff options
context:
space:
mode:
authorSami Kerola2014-04-09 22:13:51 +0200
committerSami Kerola2014-04-26 20:04:56 +0200
commitd39182c1e0a043a55832939d3a5ae0055cdc818f (patch)
treefad1212509c5978845f2f2d3403046a4d346b760 /tests/ts/kill
parenttests: add signal receiver program (diff)
downloadkernel-qcow2-util-linux-d39182c1e0a043a55832939d3a5ae0055cdc818f.tar.gz
kernel-qcow2-util-linux-d39182c1e0a043a55832939d3a5ae0055cdc818f.tar.xz
kernel-qcow2-util-linux-d39182c1e0a043a55832939d3a5ae0055cdc818f.zip
tests: check kill is converting signals names correctly
CC: Bernhard Voelker <mail@bernhard-voelker.de> Signed-off-by: Sami Kerola <kerolasa@iki.fi>
Diffstat (limited to 'tests/ts/kill')
-rwxr-xr-xtests/ts/kill/name_to_number74
1 files changed, 74 insertions, 0 deletions
diff --git a/tests/ts/kill/name_to_number b/tests/ts/kill/name_to_number
new file mode 100755
index 000000000..a6a70fc58
--- /dev/null
+++ b/tests/ts/kill/name_to_number
@@ -0,0 +1,74 @@
+#!/bin/bash
+
+# This file is part of util-linux.
+#
+# This file is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This file is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+
+TS_TOPDIR="${0%/*}/../.."
+TS_DESC="name_to_number"
+
+. "$TS_TOPDIR/functions.sh"
+ts_init "$*"
+
+ts_check_test_command "$TS_CMD_KILL"
+ts_check_test_command "$TS_HELPER_SIGRECEIVE"
+
+all_ok=true
+HELPER_SYMLINK="$TS_OUTDIR/$(mktemp -u XXXXXXXXXXXXXXX)"
+ln -s "$TS_HELPER_SIGRECEIVE" "$HELPER_SYMLINK"
+
+for SIG in $($TS_CMD_KILL -L); do
+ if [ "x${SIG//[0-9]/}" = "x" ]; then
+ EXPECTED=$SIG
+ continue
+ fi
+ if [ "x$SIG" = "xSTOP" ] || [ "x$SIG" = "xKILL" ]; then
+ continue
+ fi
+ if [ "x$SIG" = "xRTMIN" ]; then
+ SIG="$SIG+0"
+ fi
+ if [ "x$SIG" = "xRTMAX" ]; then
+ SIG="$SIG-0"
+ fi
+ "$HELPER_SYMLINK" >> "$TS_OUTPUT" 2>&1 &
+ TEST_PID=$!
+ # test_sigreceive needs time to start up
+ up=0
+ for i in 0.01 0.1 1 1 1 1; do
+ awk 'BEGIN { retval=1 }
+ $1 ~ /^SigCgt/ {
+ lbyte = strtonum("0x" substr($2, 16, 16))
+ if (and(lbyte, 1)) {
+ retval=0
+ }
+ } END {
+ exit retval
+ }' /proc/$TEST_PID/status &&
+ up=1 &&
+ break
+ sleep $i
+ done
+ test $up = 0 && echo "$SIG sigreceive ${HELPER_SYMLINK##*/} helper did not start" >> "$TS_OUTPUT"
+ "$TS_CMD_KILL" -$SIG ${HELPER_SYMLINK##*/} >> "$TS_OUTPUT" 2>&1
+ wait $TEST_PID
+ if [ $? -ne $EXPECTED ]; then
+ echo "$SIG returned $? while $EXPECTED was expected" >> "$TS_OUTPUT"
+ all_ok=false
+ fi
+done
+
+if $all_ok; then
+ echo 'all ok' >> $TS_OUTPUT
+fi
+rm -f "$HELPER_SYMLINK"
+
+ts_finalize